// 009 u_cgi_tutorial
// 02 jan 2005

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_cgi_tutorial;
  Interface

    procedure handle_order(p_write_path, p_log_name: String);

  Implementation
    uses Windows, Classes, SysUtils
        , u_c_cgi_log
        , u_cgi_helpers
        ;

    const k_content_type= 'Content-type: text/html';

          // k_output='resu.txt';
          k_output= '';

    procedure handle_order(p_write_path, p_log_name: String);

      procedure analyze_order;
        var l_raw_request_string: String;
        begin
          write_log('REQUEST_METHOD: '+ f_request_method);
          write_log('CONTENT_LENGTH: '+ IntToStr(f_content_length));

          l_raw_request_string:= f_raw_request_string;
          write_log('raw_request   : '+ l_raw_request_string);
          write_log('request       : '+ f_convert_special_characters(l_raw_request_string));
        end; // analyze_order

      procedure send_simple_ok_answer;
          // -- build a simple answer
        var l_output: Text;
            l_c_parameter_list: tStringList;
            l_parameter: Integer;
            l_acknowledge_order: String;
        begin
          write_log('send_ok_answer');

          l_c_parameter_list:= f_c_parameter_list;
          for l_parameter:= 0 to l_c_parameter_list.Count- 1 do
            write_log(l_c_parameter_list[l_parameter]);
          with l_c_parameter_list do
            l_acknowledge_order:= ' de <B><FONT COLOR=#FF0000>'+ Values['quantite']+ '</FONT>'
                + ' <FONT COLOR=#0000FF>'+ Values['livre']+ '</FONT></B>';
          l_c_parameter_list.Free;

          Assign(l_output, k_output);
          Rewrite(l_output);

          writeln(l_output, k_content_type);
          writeln(l_output);

          writeln(l_output, '<HTML>');
          writeln(l_output, '  <BODY>');
          writeln(l_output, '    Merci pour la commande '+ l_acknowledge_order
              + ' et bonne journe');
          writeln(l_output, '  </BODY>');
          writeln(l_output, '</HTML>');
          Close(l_output);

          write_log(' sent_ok_answer');
        end; // send_simple_ok_answer

      begin // handle_order
        // get_cgi_exe_path;

        open_log(f_cgi_exe_path+ p_write_path+ p_log_name);

        // write_log('ENVIRONMENT: '+ f_get_all_environment);
        analyze_order;

        send_simple_ok_answer;
      end; // handle_order

    end.